Index: branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -45,4 +45,7 @@
 #include "TLibDecoder/AnnexBread.h"
 #include "TLibDecoder/NALread.h"
+#if RExt__DECODER_DEBUG_BIT_STATISTICS
+#include "TLibCommon/TComCodingStatistics.h"
+#endif
 
 //! \ingroup TAppDecoder
@@ -54,5 +57,5 @@
 
 TAppDecTop::TAppDecTop()
-#if !H_MV
+#if !NH_MV
 : m_iPOCLastDisplay(-MAX_INT)
 #else
@@ -60,5 +63,5 @@
 #endif
 {
-#if H_MV
+#if NH_MV
   for (Int i = 0; i < MAX_NUM_LAYER_IDS; i++) 
   {
@@ -67,9 +70,9 @@
   }
 #endif
-#if H_3D
+#if NH_3D
     m_pScaleOffsetFile  = 0;
 #endif
 
-#if H_MV
+#if NH_MV
     m_markedForOutput = false; 
 #endif
@@ -83,4 +86,9 @@
 Void TAppDecTop::destroy()
 {
+#if NH_MV
+  // destroy internal classes
+  xDestroyDecLib();
+#endif
+
   if (m_pchBitstreamFile)
   {
@@ -88,5 +96,5 @@
     m_pchBitstreamFile = NULL;
   }
-#if H_MV
+#if NH_MV
   for (Int decIdx = 0; decIdx < m_numDecoders; decIdx++)
   {
@@ -103,5 +111,5 @@
     m_pchReconFile = NULL;
   }
-#if H_3D
+#if NH_3D
   if (m_pchScaleOffsetFile)
   {
@@ -127,5 +135,5 @@
 {
   Int                 poc;
-#if H_MV
+#if NH_MV
   poc = -1; 
 #endif
@@ -138,6 +146,5 @@
     exit(EXIT_FAILURE);
   }
-
-#if H_3D
+#if NH_3D
   if( m_pchScaleOffsetFile ) 
   { 
@@ -146,10 +153,21 @@
   }
 #endif
+
   InputByteStream bytestream(bitstreamFile);
+
+  if (!m_outputDecodedSEIMessagesFilename.empty() && m_outputDecodedSEIMessagesFilename!="-")
+  {
+    m_seiMessageFileStream.open(m_outputDecodedSEIMessagesFilename.c_str(), std::ios::out);
+    if (!m_seiMessageFileStream.is_open() || !m_seiMessageFileStream.good())
+    {
+      fprintf(stderr, "\nUnable to open file `%s' for writing decoded SEI messages\n", m_outputDecodedSEIMessagesFilename.c_str());
+      exit(EXIT_FAILURE);
+    }
+  }
 
   // create & initialize internal classes
   xCreateDecLib();
   xInitDecLib  ();
-#if !H_MV
+#if !NH_MV
   m_iPOCLastDisplay += m_iSkipFrame;      // set the last displayed POC correctly for skip forward.
 
@@ -169,5 +187,5 @@
   Bool firstSlice        = true; 
 #endif
-  Bool loopFiltered      = false;
+  Bool loopFiltered = false;
 
   while (!!bitstreamFile)
@@ -177,6 +195,11 @@
      * requires the TDecTop::decode() method to be called again with the same
      * nal unit. */
+#if RExt__DECODER_DEBUG_BIT_STATISTICS
+    TComCodingStatistics::TComCodingStatisticsData backupStats(TComCodingStatistics::GetStatistics());
+    streampos location = bitstreamFile.tellg() - streampos(bytestream.GetNumBufferedBytes());
+#else
     streampos location = bitstreamFile.tellg();
-#if H_MV
+#endif
+#if NH_MV
 #if ENC_DEC_TRACE
     Int64 symCount = g_nSymbolCounter;
@@ -184,11 +207,11 @@
 #endif
     AnnexBStats stats = AnnexBStats();
-    vector<uint8_t> nalUnit;
+
     InputNALUnit nalu;
-    byteStreamNALUnit(bytestream, nalUnit, stats);
+    byteStreamNALUnit(bytestream, nalu.getBitstream().getFifo(), stats);
 
     // call actual decoding function
     Bool bNewPicture = false;
-#if H_MV
+#if NH_MV
     Bool newSliceDiffPoc   = false;
     Bool newSliceDiffLayer = false;
@@ -196,5 +219,5 @@
     Bool allLayersDecoded  = false;     
 #endif
-    if (nalUnit.empty())
+    if (nalu.getBitstream().getFifo().empty())
     {
       /* this can happen if the following occur:
@@ -207,12 +230,11 @@
     else
     {
-      read(nalu, nalUnit);
-#if H_MV      
+      read(nalu);
+#if NH_MV      
       if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) 
           || !isNaluWithinTargetDecLayerIdSet(&nalu)
-          || nalu.m_layerId > MAX_NUM_LAYER_IDS-1
-          || (nalu.m_nalUnitType == NAL_UNIT_VPS && nalu.m_layerId > 0)           
-          || (nalu.m_nalUnitType == NAL_UNIT_EOB && nalu.m_layerId > 0)    
-          || (nalu.m_nalUnitType == NAL_UNIT_EOS && nalu.m_layerId > 0)    
+          || nalu.m_nuhLayerId > MAX_NUM_LAYER_IDS-1
+          || (nalu.m_nalUnitType == NAL_UNIT_VPS && nalu.m_nuhLayerId > 0)           
+          || (nalu.m_nalUnitType == NAL_UNIT_EOB && nalu.m_nuhLayerId > 0)              
          ) 
       {
@@ -225,6 +247,6 @@
       else
       { 
-        Int decIdx     = xGetDecoderIdx( nalu.m_layerId , true );      
-        newSliceDiffLayer = nalu.isSlice() && ( nalu.m_layerId != layerIdCurrPic ) && !firstSlice;
+        Int decIdx     = xGetDecoderIdx( nalu.m_nuhLayerId , true );      
+        newSliceDiffLayer = nalu.isSlice() && ( nalu.m_nuhLayerId != layerIdCurrPic ) && !firstSlice;
         newSliceDiffPoc   = m_tDecTop[decIdx]->decode(nalu, m_iSkipFrame, m_pocLastDisplay[decIdx], newSliceDiffLayer, sliceSkippedFlag );
         // decode function only returns true when all of the following conditions are true
@@ -233,31 +255,33 @@
         // - nalu.isSlice() == true      
 
-        if ( nalu.m_nalUnitType == NAL_UNIT_VPS )
-        {
-          m_vps = m_tDecTop[decIdx]->getPrefetchedVPS(); 
+        bNewPicture       = ( newSliceDiffLayer || newSliceDiffPoc ) && !sliceSkippedFlag; 
+        if ( nalu.isSlice() && firstSlice && !sliceSkippedFlag )        
+        {
+          layerIdCurrPic = nalu.m_nuhLayerId; 
+          pocCurrPic     = m_tDecTop[decIdx]->getCurrPoc(); 
+          decIdxCurrPic  = decIdx; 
+          firstSlice     = false; 
+
+          /// Use VPS activated by the first slice to determine OLS
+          m_vps = m_tDecTop[decIdx]->getActiveVPS( );
           if ( m_targetDecLayerIdSetFileEmpty )
-          {
-            TComVPS* vps = m_vps; 
+          {            
             if ( m_targetOptLayerSetIdx == -1 )
             {
-              // Not normative! Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
-              m_targetOptLayerSetIdx = vps->getVpsNumLayerSetsMinus1(); 
+              m_targetOptLayerSetIdx = m_tDecTop[decIdx]->getTargetOlsIdx(); 
             }
-
-            for (Int dI = 0; dI < m_numDecoders; dI++ )
+            else
             {
-              m_tDecTop[decIdx]->setTargetOptLayerSetIdx( m_targetOptLayerSetIdx ); 
-#if H_3D
-              m_tDecTop[decIdx]->setProfileIdc( ); 
-#endif
+              assert( m_tDecTop[decIdx]->getTargetOlsIdx() == m_targetOptLayerSetIdx );
             }
 
-            if ( m_targetOptLayerSetIdx < 0 || m_targetOptLayerSetIdx >= vps->getNumOutputLayerSets() )
+            if ( m_targetOptLayerSetIdx < 0 || m_targetOptLayerSetIdx >= m_vps->getNumOutputLayerSets() )
             {
-              fprintf(stderr, "\ntarget output layer set index must be in the range of 0 to %d, inclusive \n", vps->getNumOutputLayerSets() - 1 );            
+              fprintf(stderr, "\ntarget output layer set index must be in the range of 0 to %d, inclusive \n", m_vps->getNumOutputLayerSets() - 1 );            
               exit(EXIT_FAILURE);
             }
-            m_targetDecLayerIdSet = vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
+            m_targetDecLayerIdSet = m_vps->getTargetDecLayerIdList( m_targetOptLayerSetIdx ); 
           }
+
           if (m_outputVpsInfo )
           {
@@ -267,29 +291,15 @@
             m_vps->printPTL(); 
           }
-        }
-#if H_3D
-        if (nalu.m_nalUnitType == NAL_UNIT_VPS )
-        {                  
-          m_cCamParsCollector.init( m_pScaleOffsetFile, m_tDecTop[decIdx]->getPrefetchedVPS() );
-        }       
-#endif
-        bNewPicture       = ( newSliceDiffLayer || newSliceDiffPoc ) && !sliceSkippedFlag; 
-        if ( nalu.isSlice() && firstSlice && !sliceSkippedFlag )        
-        {
-          layerIdCurrPic = nalu.m_layerId; 
-          pocCurrPic     = m_tDecTop[decIdx]->getCurrPoc(); 
-          decIdxCurrPic  = decIdx; 
-          firstSlice     = false; 
-        }
-
-        if ( bNewPicture || !bitstreamFile )
+        }        
+
+        if ( bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS )
         { 
           layerIdLastPic    = layerIdCurrPic; 
-          layerIdCurrPic    = nalu.m_layerId; 
+          layerIdCurrPic    = nalu.m_nuhLayerId; 
           pocLastPic        = pocCurrPic; 
           pocCurrPic        = m_tDecTop[decIdx]->getCurrPoc(); 
           decIdxLastPic     = decIdxCurrPic; 
           decIdxCurrPic     = decIdx; 
-          allLayersDecoded = ( pocCurrPic != pocLastPic );
+          allLayersDecoded = ( pocCurrPic != pocLastPic ) && ( nalu.m_nalUnitType != NAL_UNIT_EOS );
         }
 #else
@@ -309,6 +319,12 @@
            * [1] except for the first NAL unit in the file
            *     (but bNewPicture doesn't happen then) */
+#if RExt__DECODER_DEBUG_BIT_STATISTICS
+          bitstreamFile.seekg(location);
+          bytestream.reset();
+          TComCodingStatistics::SetStatistics(backupStats);
+#else
           bitstreamFile.seekg(location-streamoff(3));
           bytestream.reset();
+#endif
 #if H_MV_ENC_DEC_TRAC
 #if ENC_DEC_TRACE
@@ -327,9 +343,16 @@
       }
     }
-    if (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS )
+
+    if ( (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS) &&
+#if NH_MV      
+      !m_tDecTop[decIdxLastPic]->getFirstSliceInSequence () )
+#else
+      !m_cTDecTop.getFirstSliceInSequence () )
+#endif
+
     {
       if (!loopFiltered || bitstreamFile)
       {
-#if H_MV
+#if NH_MV
         assert( decIdxLastPic != -1 ); 
         m_tDecTop[decIdxLastPic]->endPicDecoding(poc, pcListPic, m_targetDecLayerIdSet );
@@ -340,14 +363,28 @@
       }
       loopFiltered = (nalu.m_nalUnitType == NAL_UNIT_EOS);
-    }
-#if !FIX_WRITING_OUTPUT
-#if SETTING_NO_OUT_PIC_PRIOR
-    if (bNewPicture && m_cTDecTop.getIsNoOutputPriorPics())
-    {
-      m_cTDecTop.checkNoOutputPriorPics( pcListPic );
-    }
-#endif
-#endif
-#if H_3D
+      if (nalu.m_nalUnitType == NAL_UNIT_EOS)
+      {
+#if NH_MV      
+        m_tDecTop[decIdxLastPic]->setFirstSliceInSequence(true);
+#else
+        m_cTDecTop.setFirstSliceInSequence(true);
+#endif
+      }
+    }
+    else if ( (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS ) &&
+#if NH_MV      
+              m_tDecTop[decIdxLastPic]->getFirstSliceInSequence () ) 
+#else
+              m_cTDecTop.getFirstSliceInSequence () ) 
+#endif
+    {
+#if NH_MV      
+      m_tDecTop[decIdxLastPic]->setFirstSliceInPicture (true);
+#else
+      m_cTDecTop.setFirstSliceInPicture (true);
+#endif
+    }
+
+#if NH_3D
     if ( allLayersDecoded || !bitstreamFile )
     {
@@ -363,18 +400,22 @@
     if( pcListPic )
     {
-#if H_MV
+#if NH_MV
       if ( m_pchReconFiles[decIdxLastPic] && !m_reconOpen[decIdxLastPic] )
 #else
-      if ( m_pchReconFile && !openedReconFile  )
-#endif
-      {
-        if (!m_outputBitDepthY) { m_outputBitDepthY = g_bitDepthY; }
-        if (!m_outputBitDepthC) { m_outputBitDepthC = g_bitDepthC; }
-
-#if H_MV
-        m_tVideoIOYuvReconFile[decIdxLastPic]->open( m_pchReconFiles[decIdxLastPic], true, m_outputBitDepthY, m_outputBitDepthC, g_bitDepthY, g_bitDepthC ); // write mode
+      if ( m_pchReconFile && !openedReconFile )
+#endif
+      {
+        const BitDepths &bitDepths=pcListPic->front()->getPicSym()->getSPS().getBitDepths(); // use bit depths of first reconstructed picture.
+        for (UInt channelType = 0; channelType < MAX_NUM_CHANNEL_TYPE; channelType++)
+        {
+          if (m_outputBitDepth[channelType] == 0)
+          {
+            m_outputBitDepth[channelType] = bitDepths.recon[channelType];
+          }
+        }
+#if NH_MV
+        m_tVideoIOYuvReconFile[decIdxLastPic]->open( m_pchReconFiles[decIdxLastPic], true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
         m_reconOpen[decIdxLastPic] = true;
       }
-#if FIX_WRITING_OUTPUT
       // write reconstruction to file
       if( bNewPicture )
@@ -388,5 +429,4 @@
         xWriteOutput( pcListPic, decIdxLastPic, nalu.m_temporalId );
       }
-#if SETTING_NO_OUT_PIC_PRIOR
       if ( (bNewPicture || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_CRA) && m_tDecTop[decIdxLastPic]->getNoOutputPriorPicsFlag() )
       {
@@ -394,12 +434,10 @@
         m_tDecTop[decIdxLastPic]->setNoOutputPriorPicsFlag (false);
       }
-#endif
-#endif
+
       if ( bNewPicture && newSliceDiffPoc && 
 #else
-        m_cTVideoIOYuvReconFile.open( m_pchReconFile, true, m_outputBitDepthY, m_outputBitDepthC, g_bitDepthY, g_bitDepthC ); // write mode
-        openedReconFile  = true;
-      }
-#if FIX_WRITING_OUTPUT
+        m_cTVideoIOYuvReconFile.open( m_pchReconFile, true, m_outputBitDepth, m_outputBitDepth, bitDepths.recon ); // write mode
+        openedReconFile = true;
+      }
       // write reconstruction to file
       if( bNewPicture )
@@ -407,5 +445,4 @@
         xWriteOutput( pcListPic, nalu.m_temporalId );
       }
-#if SETTING_NO_OUT_PIC_PRIOR
       if ( (bNewPicture || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_CRA) && m_cTDecTop.getNoOutputPriorPicsFlag() )
       {
@@ -413,7 +450,6 @@
         m_cTDecTop.setNoOutputPriorPicsFlag (false);
       }
-#endif
-#endif
-      if ( bNewPicture && 
+
+      if ( bNewPicture &&
 #endif
            (   nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR_W_RADL
@@ -423,5 +459,5 @@
             || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA_W_LP ) )
       {
-#if H_MV
+#if NH_MV
         xFlushOutput( pcListPic, decIdxLastPic );
 #else
@@ -431,30 +467,22 @@
       if (nalu.m_nalUnitType == NAL_UNIT_EOS)
       {
-#if H_MV
-#if FIX_OUTPUT_EOS
-        xWriteOutput( pcListPic, decIdxLastPic, nalu.m_temporalId );
-#else
-        xFlushOutput( pcListPic, decIdxLastPic );
-#endif
-#else
-#if FIX_OUTPUT_EOS
+#if NH_MV
+        xWriteOutput( pcListPic, decIdxCurrPic, nalu.m_temporalId );
+#else
         xWriteOutput( pcListPic, nalu.m_temporalId );
-#else
-        xFlushOutput( pcListPic );
-#endif
-
-#endif
-      }
-      // write reconstruction to file -- for additional bumping as defined in C.5.2.3 
-#if H_MV
+#endif
+#if NH_MV
+        m_tDecTop[decIdxCurrPic]->setFirstSliceInPicture (false);
+#else
+        m_cTDecTop.setFirstSliceInPicture (false);
+#endif
+      }
+      // write reconstruction to file -- for additional bumping as defined in C.5.2.3
+#if NH_MV
       // Above comment seems to be wrong
 #endif
-#if FIX_WRITING_OUTPUT
       if(!bNewPicture && nalu.m_nalUnitType >= NAL_UNIT_CODED_SLICE_TRAIL_N && nalu.m_nalUnitType <= NAL_UNIT_RESERVED_VCL31)
-#else
-      if(bNewPicture)
-#endif
-      {
-#if H_MV        
+      {
+#if NH_MV        
         // Bumping after reference picture set has been applied (here after first vcl nalu. 
 #if ENC_DEC_TRACE
@@ -471,6 +499,6 @@
     }
   }
-#if H_MV
-#if H_3D
+#if NH_MV
+#if NH_3D
   if( m_cCamParsCollector.isInitialized() )
   {
@@ -486,8 +514,7 @@
   // delete buffers
   m_cTDecTop.deletePicBuffer();
-#endif
-     
   // destroy internal classes
   xDestroyDecLib();
+#endif
 }
 
@@ -498,5 +525,5 @@
 Void TAppDecTop::xCreateDecLib()
 {
-#if H_MV
+#if NH_MV
   // initialize global variables
   initROM();  
@@ -512,5 +539,5 @@
 Void TAppDecTop::xDestroyDecLib()
 {
-#if H_MV
+#if NH_MV
   // destroy ROM
   destroyROM();
@@ -538,9 +565,9 @@
     m_cTVideoIOYuvReconFile. close();
   }
-  
+
   // destroy decoder class
   m_cTDecTop.destroy();
 #endif
-#if H_3D
+#if NH_3D
   m_cCamParsCollector.uninit();
   if( m_pScaleOffsetFile ) 
@@ -553,15 +580,27 @@
 Void TAppDecTop::xInitDecLib()
 {
-#if !H_MV
+
+#if NH_3D
+  m_cCamParsCollector.setCodeScaleOffsetFile( m_pScaleOffsetFile );
+#endif
+#if !NH_MV
   // initialize decoder class
   m_cTDecTop.init();
   m_cTDecTop.setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
+#if O0043_BEST_EFFORT_DECODING
+  m_cTDecTop.setForceDecodeBitDepth(m_forceDecodeBitDepth);
+#endif
+  if (!m_outputDecodedSEIMessagesFilename.empty())
+  {
+    std::ostream &os=m_seiMessageFileStream.is_open() ? m_seiMessageFileStream : std::cout;
+    m_cTDecTop.setDecodedSEIMessageOutputStream(&os);
+  }
 #endif
 }
 
 /** \param pcListPic list of pictures to be written to file
-    \todo            DYN_REF_FREE should be revised
+    \param tId       temporal sub-layer ID
  */
-#if H_MV
+#if NH_MV
 Void TAppDecTop::xWriteOutput( TComList<TComPic*>* pcListPic, Int decIdx, Int tId )
 #else
@@ -569,5 +608,4 @@
 #endif
 {
-
   if (pcListPic->empty())
   {
@@ -578,9 +616,6 @@
   Int numPicsNotYetDisplayed = 0;
   Int dpbFullness = 0;
-#if H_MV
-  TComSPS* activeSPS = m_tDecTop[ decIdx ]->getActiveSPS();
-#else
-  TComSPS* activeSPS = m_cTDecTop.getActiveSPS();
-#endif
+  const TComSPS* activeSPS = &(pcListPic->front()->getPicSym()->getSPS());
+
   UInt numReorderPicsHighestTid;
   UInt maxDecPicBufferingHighestTid;
@@ -597,9 +632,9 @@
     maxDecPicBufferingHighestTid = activeSPS->getMaxDecPicBuffering(m_iMaxTemporalLayer); 
   }
-  
+
   while (iterPic != pcListPic->end())
   {
     TComPic* pcPic = *(iterPic);
-#if H_MV
+#if NH_MV
     if(pcPic->getOutputMark() && pcPic->getPOC() > m_pocLastDisplay[decIdx])
 #else
@@ -607,5 +642,5 @@
 #endif
     {
-      numPicsNotYetDisplayed++;
+       numPicsNotYetDisplayed++;
       dpbFullness++;
     }
@@ -616,10 +651,12 @@
     iterPic++;
   }
-  iterPic   = pcListPic->begin();
+
+  iterPic = pcListPic->begin();
+
   if (numPicsNotYetDisplayed>2)
   {
     iterPic++;
   }
-  
+
   TComPic* pcPic = *(iterPic);
   if (numPicsNotYetDisplayed>2 && pcPic->isField()) //Field Decoding
@@ -633,8 +670,10 @@
       iterPic++;
       TComPic* pcPicBottom = *(iterPic);
-      
-#if H_MV
-      if ( pcPicTop->getOutputMark() && (numPicsNotYetDisplayed >  pcPicTop->getNumReorderPics(tId) && !(pcPicTop->getPOC()%2) && pcPicBottom->getPOC() == pcPicTop->getPOC()+1)
-          && pcPicBottom->getOutputMark() && (numPicsNotYetDisplayed >  pcPicBottom->getNumReorderPics(tId) && (pcPicTop->getPOC() == m_pocLastDisplay[decIdx]+1 || m_pocLastDisplay[decIdx]<0)))
+
+#if NH_MV
+      if ( pcPicTop->getOutputMark() && pcPicBottom->getOutputMark() &&
+        (numPicsNotYetDisplayed >  numReorderPicsHighestTid || dpbFullness > maxDecPicBufferingHighestTid) &&
+        (!(pcPicTop->getPOC()%2) && pcPicBottom->getPOC() == pcPicTop->getPOC()+1) &&
+        (pcPicTop->getPOC() == m_pocLastDisplay[decIdx]+1 || m_pocLastDisplay[decIdx] < 0))
 #else
       if ( pcPicTop->getOutputMark() && pcPicBottom->getOutputMark() &&
@@ -646,5 +685,5 @@
         // write to file
         numPicsNotYetDisplayed = numPicsNotYetDisplayed-2;
-#if H_MV
+#if NH_MV
       if ( m_pchReconFiles[decIdx] )
 #else
@@ -653,8 +692,21 @@
         {
           const Window &conf = pcPicTop->getConformanceWindow();
-          const Window &defDisp = m_respectDefDispWindow ? pcPicTop->getDefDisplayWindow() : Window();
-
+          const Window  defDisp = m_respectDefDispWindow ? pcPicTop->getDefDisplayWindow() : Window();
           const Bool isTff = pcPicTop->isTopField();
-#if H_MV
+
+          Bool display = true;
+          if( m_decodedNoDisplaySEIEnabled )
+          {
+            SEIMessages noDisplay = getSeisByType(pcPic->getSEIs(), SEI::NO_DISPLAY );
+            const SEINoDisplay *nd = ( noDisplay.size() > 0 ) ? (SEINoDisplay*) *(noDisplay.begin()) : NULL;
+            if( (nd != NULL) && nd->m_noDisplay )
+            {
+              display = false;
+            }
+          }
+
+          if (display)
+          {
+#if NH_MV
         assert( conf   .getScaledFlag() );
         assert( defDisp.getScaledFlag() );
@@ -667,49 +719,39 @@
         m_tVideoIOYuvReconFile[decIdx]->write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
 #else
-          m_cTVideoIOYuvReconFile.write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
-#endif
-                                        conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
-                                        conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
-                                        conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-                                        conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), isTff );
-        }
-        
+        m_cTVideoIOYuvReconFile.write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
+#endif
+                                           m_outputColourSpaceConvert,
+                                           conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                           conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                           conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+#if NH_3D
+                                           conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), m_depth420OutputFlag && pcPicTop->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT, isTff );
+#else
+                                           conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), NUM_CHROMA_FORMAT, isTff );
+#endif
+          }
+        }
+
         // update POC of display order
-#if H_MV
+#if NH_MV
         m_pocLastDisplay[decIdx] = pcPic->getPOC();
 #else
         m_iPOCLastDisplay = pcPicBottom->getPOC();
 #endif
-        
+
         // erase non-referenced picture in the reference picture list after display
         if ( !pcPicTop->getSlice(0)->isReferenced() && pcPicTop->getReconMark() == true )
         {
-#if !DYN_REF_FREE
           pcPicTop->setReconMark(false);
-          
+
           // mark it should be extended later
           pcPicTop->getPicYuvRec()->setBorderExtension( false );
-          
-#else
-          pcPicTop->destroy();
-          pcListPic->erase( iterPic );
-          iterPic = pcListPic->begin(); // to the beginning, non-efficient way, have to be revised!
-          continue;
-#endif
         }
         if ( !pcPicBottom->getSlice(0)->isReferenced() && pcPicBottom->getReconMark() == true )
         {
-#if !DYN_REF_FREE
           pcPicBottom->setReconMark(false);
-          
+
           // mark it should be extended later
           pcPicBottom->getPicYuvRec()->setBorderExtension( false );
-          
-#else
-          pcPicBottom->destroy();
-          pcListPic->erase( iterPic );
-          iterPic = pcListPic->begin(); // to the beginning, non-efficient way, have to be revised!
-          continue;
-#endif
         }
         pcPicTop->setOutputMark(false);
@@ -721,9 +763,10 @@
   {
     iterPic = pcListPic->begin();
+
     while (iterPic != pcListPic->end())
     {
       pcPic = *(iterPic);
 
-#if H_MV
+#if NH_MV
       if(pcPic->getOutputMark() && pcPic->getPOC() > m_pocLastDisplay[decIdx] &&
         (numPicsNotYetDisplayed >  numReorderPicsHighestTid || dpbFullness > maxDecPicBufferingHighestTid))
@@ -734,10 +777,10 @@
       {
         // write to file
-        numPicsNotYetDisplayed--;
+         numPicsNotYetDisplayed--;
         if(pcPic->getSlice(0)->isReferenced() == false)
         {
           dpbFullness--;
         }
-#if H_MV
+#if NH_MV
       if ( m_pchReconFiles[decIdx] )
 #else
@@ -745,7 +788,7 @@
 #endif
         {
-          const Window &conf = pcPic->getConformanceWindow();
-          const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
-#if H_MV
+          const Window &conf    = pcPic->getConformanceWindow();
+          const Window defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+#if NH_MV
         assert( conf   .getScaledFlag() );
         assert( defDisp.getScaledFlag() );
@@ -760,47 +803,46 @@
           m_cTVideoIOYuvReconFile.write( pcPic->getPicYuvRec(),
 #endif
-                                        conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
-                                        conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
-                                        conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-                                        conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
-        }
-        
+                                         m_outputColourSpaceConvert,
+                                         conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                         conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                         conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), 
+#if NH_3D
+                                          m_depth420OutputFlag && pcPic->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT,
+#else
+                                          NUM_CHROMA_FORMAT,
+#endif
+           m_bClipOutputVideoToRec709Range   );
+        }
+
         // update POC of display order
-#if H_MV
+#if NH_MV
         m_pocLastDisplay[decIdx] = pcPic->getPOC();
 #else
         m_iPOCLastDisplay = pcPic->getPOC();
 #endif
-        
+
         // erase non-referenced picture in the reference picture list after display
         if ( !pcPic->getSlice(0)->isReferenced() && pcPic->getReconMark() == true )
         {
-#if !DYN_REF_FREE
           pcPic->setReconMark(false);
-          
+
           // mark it should be extended later
           pcPic->getPicYuvRec()->setBorderExtension( false );
-          
-#else
-          pcPic->destroy();
-          pcListPic->erase( iterPic );
-          iterPic = pcListPic->begin(); // to the beginning, non-efficient way, have to be revised!
-          continue;
-#endif
         }
         pcPic->setOutputMark(false);
-#if H_MV
+#if NH_MV
         pcPic->setPicOutputFlag(false);
 #endif
       }
-      
+
       iterPic++;
     }
   }
 }
+
 /** \param pcListPic list of pictures to be written to file
-    \todo            DYN_REF_FREE should be revised
  */
-#if H_MV
+#if NH_MV
 Void TAppDecTop::xFlushOutput( TComList<TComPic*>* pcListPic, Int decIdx )
 #else
@@ -813,8 +855,8 @@
   }
   TComList<TComPic*>::iterator iterPic   = pcListPic->begin();
-  
+
   iterPic   = pcListPic->begin();
   TComPic* pcPic = *(iterPic);
-  
+
   if (pcPic->isField()) //Field Decoding
   {
@@ -827,9 +869,9 @@
       iterPic++;
       pcPicBottom = *(iterPic);
-      
+
       if ( pcPicTop->getOutputMark() && pcPicBottom->getOutputMark() && !(pcPicTop->getPOC()%2) && (pcPicBottom->getPOC() == pcPicTop->getPOC()+1) )
       {
         // write to file
-#if H_MV
+#if NH_MV
       if ( m_pchReconFiles[decIdx] )
 #else
@@ -838,7 +880,7 @@
         {
           const Window &conf = pcPicTop->getConformanceWindow();
-          const Window &defDisp = m_respectDefDispWindow ? pcPicTop->getDefDisplayWindow() : Window();
+          const Window  defDisp = m_respectDefDispWindow ? pcPicTop->getDefDisplayWindow() : Window();
           const Bool isTff = pcPicTop->isTopField();
-#if H_MV
+#if NH_MV
         assert( conf   .getScaledFlag() );
         assert( defDisp.getScaledFlag() );
@@ -853,51 +895,39 @@
           m_cTVideoIOYuvReconFile.write( pcPicTop->getPicYuvRec(), pcPicBottom->getPicYuvRec(),
 #endif
-                                        conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
-                                        conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
-                                        conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
-                                        conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), isTff );
-        }
-        
+                                         m_outputColourSpaceConvert,
+                                         conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                         conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                         conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+#if NH_3D
+                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), m_depth420OutputFlag && pcPicTop->getIsDepth() ? CHROMA_420 : NUM_CHROMA_FORMAT, isTff );
+#else
+                                         conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset(), NUM_CHROMA_FORMAT, isTff );
+#endif
+        }
+
         // update POC of display order
-#if H_MV
+#if NH_MV
       m_pocLastDisplay[decIdx] = pcPic->getPOC();
 #else
-      m_iPOCLastDisplay = pcPicBottom->getPOC();
+        m_iPOCLastDisplay = pcPicBottom->getPOC();
 #endif        
         // erase non-referenced picture in the reference picture list after display
         if ( !pcPicTop->getSlice(0)->isReferenced() && pcPicTop->getReconMark() == true )
         {
-#if !DYN_REF_FREE
           pcPicTop->setReconMark(false);
-          
+
           // mark it should be extended later
           pcPicTop->getPicYuvRec()->setBorderExtension( false );
-          
-#else
-          pcPicTop->destroy();
-          pcListPic->erase( iterPic );
-          iterPic = pcListPic->begin(); // to the beginning, non-efficient way, have to be revised!
-          continue;
-#endif
         }
         if ( !pcPicBottom->getSlice(0)->isReferenced() && pcPicBottom->getReconMark() == true )
         {
-#if !DYN_REF_FREE
           pcPicBottom->setReconMark(false);
-          
+
           // mark it should be extended later
           pcPicBottom->getPicYuvRec()->setBorderExtension( false );
-          
-#else
-          pcPicBottom->destroy();
-          pcListPic->erase( iterPic );
-          iterPic = pcListPic->begin(); // to the beginning, non-efficient way, have to be revised!
-          continue;
-#endif
         }
         pcPicTop->setOutputMark(false);
         pcPicBottom->setOutputMark(false);
-        
-#if !DYN_REF_FREE
+
         if(pcPicTop)
         {
@@ -906,5 +936,4 @@
           pcPicTop = NULL;
         }
-#endif
       }
     }
@@ -921,9 +950,9 @@
     {
       pcPic = *(iterPic);
-      
+
       if ( pcPic->getOutputMark() )
       {
         // write to file
-#if H_MV
+#if NH_MV
       if ( m_pchReconFiles[decIdx] )
 #else
@@ -931,7 +960,7 @@
 #endif
         {
-          const Window &conf = pcPic->getConformanceWindow();
-          const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
-#if H_MV
+          const Window &conf    = pcPic->getConformanceWindow();
+          const Window  defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+#if NH_MV
         assert( conf   .getScaledFlag() );
         assert( defDisp.getScaledFlag() );
